/*    pong is free software: you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation, either version 3 of the License, or
      (at your option) any later version.

      pong is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with pong.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <cstring>
#include <SFML/Graphics.hpp>
#include <time.h>
#include <climits>
#include "player.h"
#include "ball.h"
#include "border.h"
#include "simpleRect.h"

#define WIDTH 800
#define HEIGHT 400

sf::Clock chrono;

bool moveUP=false;
bool moveDOWN=false;

short player1_count=0;
short player2_count=0;
short max_score=5;
short player1_winner_count=0;
short player2_winner_count=0;
std::string mode="";

float cpu_delay=0;
float player_speed=1;
int speed=3;
bool start=false;

bool player1_win=false;
bool player2_win=false;

void goal(ball &ball,player &cpu,sf::RenderWindow &window,sf::Clock &chrono,short &count1,short &count2,short &p1_win_count,short &p2_win_count)
{
	if (ball.getX() > WIDTH)
	{
		 ball.setPosition(window.getSize().x/2,window.getSize().y/2);
 		 cpu.setPosition(40,window.getSize().y/2+100);
		 ball.resetAngle();
		 ball.resetSpeed();
		 count2+=1;
		 start=false;
		 if(count2 == max_score)
		{
			player2_win=true;
		 	p2_win_count+=1;
		}
	}

	if (ball.getX() < 0)
	{
		ball.setPosition(window.getSize().x/2,window.getSize().y/2);
		cpu.setPosition(40,window.getSize().y/2+100);
		ball.resetAngle();
		ball.resetSpeed();
		count1+=1;
		start=false;
		if(count1 == max_score)
		{
			player1_win=true;
	 		p1_win_count+=1;
		}


	}
}

int main(int argc,char** argv)
{
	sf::RenderWindow window(sf::VideoMode(WIDTH,HEIGHT), "PONG!");
	srand(time(nullptr));

	player player1(10,45,window.getSize().x-50,window.getSize().y/2,sf::Color::Red);

	player cpu(10,45,40,window.getSize().y/2,sf::Color::Blue);

	ball ball(4,window.getSize().x/2,window.getSize().y/2,speed);

	std::vector<simpleRect> mediana;

	for(int i=0; i<HEIGHT-25;)
	{
		simpleRect rect(5,5,window.getSize().x/2,i+15);
		mediana.push_back(rect);
		i+=15;
	}


	if( argc == 2)
	{
		if(strcmp(argv[1],"-easy") == 0)
		{
			cpu_delay=0.8;
			cpu.setTime(0.006);
			player_speed=10;
			mode="EASY";
		}

		else if(strcmp(argv[1],"-medium") == 0)
		{
			cpu_delay=0.25;
			cpu.setTime(0.005);
			player_speed=10;
			mode="MEDIUM";

		}

		else if(strcmp(argv[1],"-hard") == 0)
		{
			cpu_delay=0.1;
			cpu.setTime(0.003);
			player_speed=20;
			mode="HARD";

		}

		else if(strcmp(argv[1],"-impossible") == 0 )
		{
			cpu_delay=0.0;
			cpu.setTime(0.001);
			player_speed=20;
			mode="IMPOSSIBLE";

		}

		else
		{
			cpu_delay=0.25;
			player_speed=10;
			mode="MEDIUM";
		}

	}


	else if( argc == 3)
	{
		if(strcmp(argv[1],"-easy") == 0)
		{
			cpu_delay=0.8;
			cpu.setTime(0.006);
			player_speed=10;
			if(max_score > 0 && max_score <= SHRT_MAX) max_score=atoi(argv[2]);
			mode="EASY";

		}

		else if(strcmp(argv[1],"-medium") == 0)
		{
			cpu_delay=0.25;
			cpu.setTime(0.005);
			player_speed=10;
			max_score=atoi(argv[2]);
			if( max_score > 0 && max_score <= SHRT_MAX) max_score=atoi(argv[2]);
			mode="MEDIUM";

		}

		else if(strcmp(argv[1],"-hard") == 0)
		{
			cpu_delay=0.1;
			cpu.setTime(0.003);
			player_speed=20;
			max_score=atoi(argv[2]);
			if(max_score > 0 && max_score <= SHRT_MAX) max_score=atoi(argv[2]);
			mode="HARD";



		}

		else if(strcmp(argv[1],"-impossible") == 0 )
		{
			cpu_delay=0.0;
			cpu.setTime(0.001);
			player_speed=20;
			max_score=atoi(argv[2]);
			if( max_score > 0 &&  max_score <= SHRT_MAX) max_score=atoi(argv[2]);
			mode="IMPOSSIBLE";


		}

		else
		{
			cpu_delay=0.25;
			player_speed=10;
			mode="MEDIUM";
		}

	}

	else
	{
		cpu_delay=0.25;
		player_speed=10;
		mode="MEDIUM";
	}





	sf::Text player1_points;
	sf::Text player2_points;

	sf::Text player1_winner;
	sf::Text player2_winner;

	sf::Text player1_winner_counter_display;
	sf::Text player2_winner_counter_display;

	sf::Text gameMode;

	sf::Font bit8;
	bit8.loadFromFile("font/8-BIT WONDER.TTF");


	player1_points.setFont(bit8);
	player2_points.setFont(bit8);

	player1_winner_counter_display.setFont(bit8);
	player2_winner_counter_display.setFont(bit8);

	gameMode.setFont(bit8);

	player1_winner.setFont(bit8);
	player2_winner.setFont(bit8);

	player1_points.setPosition(700,50);
	player2_points.setPosition(50,50);

	player1_winner.setPosition(window.getSize().x/2-180,window.getSize().y/2);
	player2_winner.setPosition(window.getSize().x/2-180,window.getSize().y/2);

	player1_winner_counter_display.setPosition(WIDTH-200,HEIGHT-15);
	player2_winner_counter_display.setPosition(100,HEIGHT-15);
	gameMode.setPosition(window.getSize().x/2-25,HEIGHT-15);

	player1_points.setCharacterSize(20);
	player2_points.setCharacterSize(20);

	player1_winner.setCharacterSize(30);
	player2_winner.setCharacterSize(30);

	player1_winner_counter_display.setCharacterSize(10);
	player2_winner_counter_display.setCharacterSize(10);
	gameMode.setCharacterSize(10);

	player1_points.setFillColor(sf::Color::White);
	player2_points.setFillColor(sf::Color::White);

	player1_winner.setFillColor(sf::Color::White);
	player2_winner.setFillColor(sf::Color::White);

	player1_winner_counter_display.setFillColor(sf::Color::White);
	player2_winner_counter_display.setFillColor(sf::Color::White);

	if(mode.compare("EASY") == 0) gameMode.setFillColor(sf::Color(0x00,0xbf,0xff));
	if(mode.compare("MEDIUM") == 0) gameMode.setFillColor(sf::Color::Green);
	if(mode.compare("HARD") == 0)gameMode.setFillColor(sf::Color::Red);
	if(mode.compare("IMPOSSIBLE") == 0)gameMode.setFillColor(sf::Color(0x66,0x33,0x99));

	player1_winner.setString("PLAYER 1 WINS");
	player2_winner.setString("PLAYER 2 WINS");

	gameMode.setString(mode);

	border topWall(WIDTH,5);
	border bottomWall(WIDTH,5);

	topWall.setPosition(0,5);
	bottomWall.setPosition(0,HEIGHT-25);


	while(window.isOpen())
	{

		if(!player1_win && !player2_win)
		{

			player1_points.setString(std::to_string(player1_count));
			player2_points.setString(std::to_string(player2_count));

			player1_winner_counter_display.setString("PLAYER "+std::to_string(player1_winner_count));
			player2_winner_counter_display.setString("CPU "+std::to_string(player2_winner_count));


			sf::Event event;

			while(window.pollEvent(event))
			{
				if(event.type == sf::Event::Closed) window.close();

				if(sf::Event::KeyReleased)
				{
					if(sf::Keyboard::Up) moveUP=false;
					if(sf::Keyboard::Down) moveDOWN=false;
			 	//if(!player1.getGlobalBounds().intersects(topWall.getGlobalBounds())) player1.moveUP(player_speed);
				}

				if(sf::Keyboard::isKeyPressed(sf::Keyboard::Up)) moveUP=true;
				if(sf::Keyboard::isKeyPressed(sf::Keyboard::Down)) moveDOWN=true;

				if(sf::Keyboard::isKeyPressed(sf::Keyboard::Space))
				{
					  ball.setPosition(window.getSize().x/2,window.getSize().y/2);
					  start = true;
				}

			}

			if(player1.getGlobalBounds().intersects(topWall.getGlobalBounds())) player1.setPosition(player1.getX(),player1.getY()+10);
			if(player1.getGlobalBounds().intersects(bottomWall.getGlobalBounds())) player1.setPosition(player1.getX(),player1.getY()-10);

			if(!player1.getGlobalBounds().intersects(topWall.getGlobalBounds()) && moveUP) player1.moveUP(player_speed);
			if(!player1.getGlobalBounds().intersects(bottomWall.getGlobalBounds()) && moveDOWN) player1.moveDOWN(player_speed);


			if(!topWall.getGlobalBounds().intersects(cpu.getGlobalBounds()))
				//0.8 facile
				//0.3 medio
				//0.1 difficile
				//0 impossibile
				if(chrono.getElapsedTime().asSeconds() > cpu_delay)
				{
					cpu.play(ball.getY(),HEIGHT);
					chrono.restart();
				}

			if(!bottomWall.getGlobalBounds().intersects(cpu.getGlobalBounds()))
				if(chrono.getElapsedTime().asSeconds() > cpu_delay)
				{
					cpu.play(ball.getY(),HEIGHT);
					chrono.restart();
				}


			if(ball.getGlobalBounds().intersects(player1.getGlobalBounds()) || ball.getGlobalBounds().intersects(cpu.getGlobalBounds()) )
			{
				ball.bounce();
			}

			if(ball.getY() < 5) ball.wall_bounce();
			else if(ball.getY() >= HEIGHT-35) ball.wall_bounce();

			if(start) ball.move();
			goal(ball,cpu,window,chrono,player1_count,player2_count,player1_winner_count,player2_winner_count);


			window.clear();
			window.draw(player1_points);
			window.draw(player2_points);
			window.draw(player1_winner_counter_display);
			window.draw(player2_winner_counter_display);
			window.draw(gameMode);
			for(auto &rect : mediana){rect.draw(window);}
			topWall.draw(window);
			bottomWall.draw(window);
			player1.draw(window);
			cpu.draw(window);
			ball.draw(window);
			window.display();
		}

	if(player1_win && !player2_win)
	{
		 sf::Event event;
		 while(window.pollEvent(event))
		 {
			if(event.type == sf::Event::Closed) window.close();

			if(sf::Keyboard::isKeyPressed(sf::Keyboard::Space))
			{
				player1_win=false;
				player2_win=false;
				player1_count=0;
				player2_count=0;
				player1.setPosition(player1.getX(),window.getSize().y/2);
			}
		 }
		 window.clear();
		 window.draw(player1_winner);
		 window.display();
	}
	if(!player1_win && player2_win)
	{
		 sf::Event event;
		 while(window.pollEvent(event))
		 {
			if(event.type == sf::Event::Closed) window.close();

			if(sf::Keyboard::isKeyPressed(sf::Keyboard::Space))
			{
				player1_win=false;
				player2_win=false;
				player1_count=0;
				player2_count=0;
				player1.setPosition(player1.getX(),window.getSize().y/2);
			}
		 }
		 window.clear();
		 window.draw(player2_winner);
		 window.display();
	}


		}

	return 0;

}

