/*    pong is free software: you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation, either version 3 of the License, or
      (at your option) any later version.

      pong is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with pong.  If not, see <http://www.gnu.org/licenses/>.

*/

class player
{
public:
	player(int width,int height,int x, int y,sf::Color color)
	{
		_player.setSize(sf::Vector2f(width,height));
		_player.setPosition(x,y);
		_player.setOutlineThickness(1);
		_player.setOutlineColor(color);
	}

	int getX()
	{
		return _player.getPosition().x;
	}

	int getY()
	{
		return _player.getPosition().y;
	}

	void setPosition(int x, int y)
	{
		_player.setPosition(x,y);
	}

	bool play(int bally ,int wh)
	{
		if(_player.getPosition().y < wh-80) _player.setPosition(_player.getPosition().x,bally-40);
		if(bally <  wh-60) _player.setPosition(_player.getPosition().x,bally);
		else return false;
	}

	void setTime(double time)
	{
		this->time=time;
	}

	void moveUP(float vel)
	{
		_player.move(0,-vel*this->time);
	}

	void moveDOWN(float vel)
	{
		_player.move(0,vel*this->time);
	}

	sf::FloatRect getGlobalBounds()
	{
		return _player.getGlobalBounds();
	}

	void draw(sf::RenderWindow &window)
	{
		window.draw(_player);
	}

private:
	double time=0.007;
	sf::RectangleShape _player;
};
